var events = require("events");
var util   = require("util");
var redis  = require("redis");
var uuid   = require("node-uuid");

var Queue = function (port, host, options) {
    if (!(this instanceof Queue)) return new Queue();
    Queue.super_.call(this);

    this.jobs_queue = redis.createClient(port,host,options);
    this.jobs_done  = redis.createClient(port,host,options);

    this.listen();
}

util.inherits(Queue,events.EventEmitter);

Queue.prototype.add_job = function (payload, next) {
    var job_id = uuid.v4();
    var packet = { 'job_id': job_id,
                   'payload': payload
                 };

    this.jobs_queue.rpush('jobs_queue', JSON.stringify(packet));
    this.once(job_id, next);
};

Queue.prototype.listen = function () {
    self = this;
    self.jobs_done.blpop('jobs_done', 0 , function (err, reply) {
        reply = JSON.parse(reply[1]);
        self.emit(reply.job_id, reply.payload);
        self.listen();
    });
};

exports.createQueue = function (port, host, options) {
    return new Queue(port, host, options);
};
